﻿using System;
using System.Drawing;

using Foundation;
using UIKit;
using Syncfusion.SfChart.iOS;
using CoreGraphics;

namespace ChartSample
{
	public partial class ChartSampleViewController : UIViewController
	{
		static bool UserInterfaceIdiomIsPhone {
			get { return UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone; }
		}

		public ChartSampleViewController (IntPtr handle) : base (handle)
		{
		}

		public override void DidReceiveMemoryWarning ()
		{
			base.DidReceiveMemoryWarning ();
		}

		#region View lifecycle

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();

			SFChart chart                         = new SFChart ();
			chart.EdgeInsets 					  = new UIEdgeInsets (25,10,10,20);
			chart.Frame                           = this.View.Frame;
			SFCategoryAxis primaryAxis     	      = new SFCategoryAxis ();
			chart.PrimaryAxis                     = primaryAxis;
			SFNumericalAxis secondaryAxis 		  = new SFNumericalAxis ();
			chart.SecondaryAxis                   = secondaryAxis;
			chart.Legend.Visible 			      = true ;

			ChartDataModel dataModel              = new ChartDataModel ();
			chart.DataSource                      = dataModel as SFChartDataSource;

			this.View.AddSubview (chart);
		}

		public override void ViewWillAppear (bool animated)
		{
			base.ViewWillAppear (animated);
		}

		public override void ViewDidAppear (bool animated)
		{
			base.ViewDidAppear (animated);
		}

		public override void ViewWillDisappear (bool animated)
		{
			base.ViewWillDisappear (animated);
		}

		public override void ViewDidDisappear (bool animated)
		{
			base.ViewDidDisappear (animated);
		}

		#endregion
	}
		
	public class ChartDataModel : SFChartDataSource
	{
		NSMutableArray Data1;
		NSMutableArray Data2;
		NSMutableArray Data3;
		NSMutableArray Data4;
		NSMutableArray Data5;
		NSMutableArray Data6;

		public ChartDataModel ()
		{
			Data1 = new NSMutableArray ();
			Data2 = new NSMutableArray ();
			Data3 = new NSMutableArray ();
			Data4 = new NSMutableArray ();
			Data5 = new NSMutableArray ();
			Data6 = new NSMutableArray ();
			Random rand   = new Random ();

			Data1.Add(new SFChartDataPoint (NSObject.FromObject ("Audi"),NSObject.FromObject ( rand.Next(10,50))));
			Data1.Add(new SFChartDataPoint (NSObject.FromObject ("Benz"), NSObject.FromObject (rand.Next(10,50))));
			Data1.Add(new SFChartDataPoint (NSObject.FromObject ("BMW"), NSObject.FromObject (rand.Next(10,50))));

			Data2.Add(new SFChartDataPoint (NSObject.FromObject ("Expenses"), NSObject.FromObject (rand.Next(25,50))));
			Data2.Add(new SFChartDataPoint (NSObject.FromObject ("Profit"), NSObject.FromObject (rand.Next(25,50))));

			Data3.Add(new SFChartDataPoint (NSObject.FromObject ("Labour"), NSObject.FromObject (rand.Next(10,50))));
			Data3.Add(new SFChartDataPoint (NSObject.FromObject ("Supervisior"), NSObject.FromObject (rand.Next(10,50))));
			Data3.Add(new SFChartDataPoint (NSObject.FromObject ("Manager"), NSObject.FromObject (rand.Next(10,50))));
			Data3.Add(new SFChartDataPoint (NSObject.FromObject ("CEO"), NSObject.FromObject (rand.Next(10,50))));

			Data4.Add(new SFChartDataPoint (NSObject.FromObject ("Published"), NSObject.FromObject (rand.Next(10,50))));
			Data4.Add(new SFChartDataPoint (NSObject.FromObject ("Cancelled"),NSObject.FromObject (rand.Next(10,50))));
			Data4.Add(new SFChartDataPoint (NSObject.FromObject ("Accepted"), NSObject.FromObject (rand.Next(10,50))));
			Data4.Add(new SFChartDataPoint (NSObject.FromObject ("Active"), NSObject.FromObject (rand.Next(10,50))));
			Data4.Add(new SFChartDataPoint (NSObject.FromObject ("Completed"), NSObject.FromObject (rand.Next(10,50))));

			Data5.Add(new SFChartDataPoint (NSObject.FromObject ("2010"), NSObject.FromObject (rand.Next(10,50))));
			Data5.Add(new SFChartDataPoint (NSObject.FromObject ("2011"), NSObject.FromObject (rand.Next(10,50))));
			Data5.Add(new SFChartDataPoint (NSObject.FromObject ("2012"), NSObject.FromObject (rand.Next(10,50))));
			Data5.Add(new SFChartDataPoint (NSObject.FromObject ("2013"), NSObject.FromObject (rand.Next(10,50))));
			Data5.Add(new SFChartDataPoint (NSObject.FromObject ("2014"), NSObject.FromObject (rand.Next(10,50))));
			Data5.Add(new SFChartDataPoint (NSObject.FromObject ("2015"), NSObject.FromObject (rand.Next(10,50))));

			Data6.Add(new SFChartDataPoint (NSObject.FromObject ("One"), NSObject.FromObject (rand.Next(10,50))));
			Data6.Add(new SFChartDataPoint (NSObject.FromObject ("Two"), NSObject.FromObject (rand.Next(10,50))));
			Data6.Add(new SFChartDataPoint (NSObject.FromObject ("Three"), NSObject.FromObject (rand.Next(10,50))));
		}


		//[Export ("numberOfSeriesInChart:")]
		public override nint NumberOfSeriesInChart (SFChart chart)
		{
			return 6; 
		}

		//[Export ("chart:seriesAtIndex:")]
		public override SFSeries GetSeries (SFChart chart, nint index)
		{
			SFLineSeries series 		= new SFLineSeries ();
			SFCategoryAxis xaxis 		= new SFCategoryAxis ();

			if (index == 0) {
				series.Label 			= new NSString ("Series1");
				xaxis.Title.Text 		= new NSString ("Series1");
			} else if (index == 1) {
				series.Label 			= new NSString ("Series2");
				xaxis.Title.Text 		= new NSString ("Series2");
			} else if (index == 2) {
				series.Label 			= new NSString ("Series3");
				xaxis.Title.Text 		= new NSString ("Series3");
			} else if (index == 3) {
				series.Label 			= new NSString ("Series4");
				xaxis.Title.Text 		= new NSString ("Series4");
				xaxis.OpposedPosition 	= true;
			} else if (index == 4) {
				series.Label 			= new NSString ("Series5");
				xaxis.Title.Text 		= new NSString ("Series5");
				xaxis.OpposedPosition 	= true;
			} else if (index == 5) {
				series.Label 			= new NSString ("Series6");
				xaxis.Title.Text 		= new NSString ("Series6");
				xaxis.OpposedPosition 	= true;
			}
	
			series.XAxis = xaxis;
			return series;
		}

		//[Export ("chart:dataPointAtIndex:forSeriesAtIndex:")]
		public override SFChartDataPoint GetDataPoint (SFChart chart, nint index, nint seriesIndex)
		{
			if (seriesIndex == 0)
				return Data1.GetItem<SFChartDataPoint> ((nuint)index);
			else if (seriesIndex == 1)
				return Data2.GetItem<SFChartDataPoint> ((nuint)index);
			else if (seriesIndex == 2)
				return Data3.GetItem<SFChartDataPoint> ((nuint)index);
			else if (seriesIndex == 3)
				return Data4.GetItem<SFChartDataPoint> ((nuint)index);
			else if (seriesIndex == 4)
				return Data5.GetItem<SFChartDataPoint> ((nuint)index);
			else
				return Data6.GetItem<SFChartDataPoint> ((nuint)index);
		}

		//[Export ("chart:numberOfDataPointsForSeriesAtIndex:")]
		public override nint GetNumberOfDataPoints (SFChart chart, nint index)
		{
			if(index == 0)
				return (int)Data1.Count;
			else if(index ==1)
				return (int)Data2.Count;
			else if(index ==2)
				return (int)Data3.Count;
			else if(index ==3)
				return (int)Data4.Count;
			else if(index ==4)
				return (int)Data5.Count;
			else 
				return (int)Data6.Count;
		}
	}
}
